<template>
  <VForm
    name="topic-create-form"
    :fields="fields"
    :modelState="modelState"
    buttonText="Create"
    buttonIconClass="bi bi-save-fill"
    :busy="creating"
    busyButtonText="Creating..."
    @submit="onSubmit"
  />
</template>

<script>
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { VForm, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import TopicsApi from '../api/topics-api.js'

export default {
  name: 'TopicCreateForm',
  components: {
    VForm,
  },
  props: {
    section: { type: Object, required: true },
  },
  setup(props) {
    const router = useRouter()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const modelState = ref({})
    const creating = ref(false)
    const fields = ref(
      [
        {
          type: 'hidden',
          name: 'sectionId',
          value: props.section.id,
        },
        {
          type: 'text',
          name: 'title',
          label: 'Title',
          maxlength: 200,
          validate: 'required',
          value: '',
        },
        {
          type: 'text',
          name: 'subHeading',
          label: 'Sub-heading',
          maxlength: 200,
          value: '',
        },
        {
          type: 'markdown',
          name: 'content',
          placeholder: 'Content',
          validate: 'required',
          value: '',
        },
      ].concat(
        props.section.classifieds
          ? [
              {
                type: 'number',
                name: 'price',
                label: 'Price',
                tooltip:
                  '"For Sale" items must have a price. "Multiple" items should have a price per item in the description.',
                validate: 'required|decimal:2',
                value: '',
              },
              {
                type: 'radio',
                name: 'status',
                label: 'Status',
                validate: 'required',
                value: '',

                options: [
                  {
                    value: '1',
                    text: 'For Sale',
                  },
                  {
                    value: '2',
                    text: 'Multiple Items',
                  },
                  {
                    value: '3',
                    text: 'E.O.I',
                  },
                  {
                    value: '4',
                    text: 'Pending Payment',
                  },
                  {
                    value: '5',
                    text: 'Sold',
                  },
                ],
              },
            ]
          : []
      )
    )

    const onSubmit = async (form) => {
      creating.value = true

      try {
        const response = await topicsApi.createAsync(form)
        notify.success('Topic created successfully.')
        router.push({
          name: 'forum-topics',
          params: { alias: response.data.alias },
        })
      } catch (ex) {
        creating.value = false
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data?.modelState
        } else {
          notify.error('There was a problem creating your topic.', ex)
        }
      } finally {
        creating.value = false
      }
    }

    return {
      modelState,
      creating,
      fields,
      onSubmit,
    }
  },
}
</script>
